<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPositionItemResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPositionItemResult_V4 extends AbstractStructArrayBase
{
    /**
     * The PositionItemResult_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PositionItemResult_V4[]
     */
    public $PositionItemResult_V4;
    /**
     * Constructor method for ArrayOfPositionItemResult_V4
     * @uses ArrayOfPositionItemResult_V4::setPositionItemResult_V4()
     * @param \StructType\PositionItemResult_V4[] $positionItemResult_V4
     */
    public function __construct(array $positionItemResult_V4 = array())
    {
        $this
            ->setPositionItemResult_V4($positionItemResult_V4);
    }
    /**
     * Get PositionItemResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PositionItemResult_V4[]|null
     */
    public function getPositionItemResult_V4()
    {
        return isset($this->PositionItemResult_V4) ? $this->PositionItemResult_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPositionItemResult_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPositionItemResult_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePositionItemResult_V4ForArrayConstraintsFromSetPositionItemResult_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPositionItemResult_V4PositionItemResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfPositionItemResult_V4PositionItemResult_V4Item instanceof \StructType\PositionItemResult_V4) {
                $invalidValues[] = is_object($arrayOfPositionItemResult_V4PositionItemResult_V4Item) ? get_class($arrayOfPositionItemResult_V4PositionItemResult_V4Item) : sprintf('%s(%s)', gettype($arrayOfPositionItemResult_V4PositionItemResult_V4Item), var_export($arrayOfPositionItemResult_V4PositionItemResult_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PositionItemResult_V4 property can only contain items of type \StructType\PositionItemResult_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PositionItemResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V4[] $positionItemResult_V4
     * @return \ArrayType\ArrayOfPositionItemResult_V4
     */
    public function setPositionItemResult_V4(array $positionItemResult_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($positionItemResult_V4ArrayErrorMessage = self::validatePositionItemResult_V4ForArrayConstraintsFromSetPositionItemResult_V4($positionItemResult_V4))) {
            throw new \InvalidArgumentException($positionItemResult_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($positionItemResult_V4) || (is_array($positionItemResult_V4) && empty($positionItemResult_V4))) {
            unset($this->PositionItemResult_V4);
        } else {
            $this->PositionItemResult_V4 = $positionItemResult_V4;
        }
        return $this;
    }
    /**
     * Add item to PositionItemResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\PositionItemResult_V4 $item
     * @return \ArrayType\ArrayOfPositionItemResult_V4
     */
    public function addToPositionItemResult_V4(\StructType\PositionItemResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PositionItemResult_V4) {
            throw new \InvalidArgumentException(sprintf('The PositionItemResult_V4 property can only contain items of type \StructType\PositionItemResult_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PositionItemResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PositionItemResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PositionItemResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PositionItemResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PositionItemResult_V4
     */
    public function getAttributeName()
    {
        return 'PositionItemResult_V4';
    }
}
